/* tlhIngan Hol pojwI' version j3.3.  The source for this proram was
   written and compiled in the Microsoft Visual C++ IDE under
   Windows 3.11, and is nearly 100% ANSI standard.

	You may have to change the following two functions:
		system("cls");
		getch();
	These are used throughout the program.

   Happy compiling.

  --

This version is modified for Unix / Open Source usage by Joel Anderson
 and adds command line options as well as the ability to add to the 
 vocabulary.   9901.17

      Joel Peter Anderson  /  jpklingon@aol.com / joela@umn.edu

  */

#include "kj3-3.h"

#define LEXFILE "kli.lex"
char temp[MAXWORD];

struct WORDLIST kli[5000+S_LEXSIZE];
int LEXSIZE;

char getch(){
  char input[250]; 
  gets(input);
if (strlen(input)==0)  return 13;
return *input;
}
/*
                                       
 ___  __ ___   _____  __   _____   ___ 
/ __|/ _` \ \ / / _ \ \ \ / / _ \ / __|
\__ \ (_| |\ V /  __/  \ V / (_) | (__ 
|___/\__,_| \_/ \___|___\_/ \___/ \___|
                   |_____|             
*/
save_voc(char *filename){
	FILE *WT;
	int x;
	char FILENM[1000];
	strcpy (FILENM,FILEHOME);
	strcat (FILENM,filename);
	if (WT = fopen(FILENM,"w")){
	for (x=S_LEXSIZE;x<LEXSIZE;x++){
	fprintf (WT,"\"%s\", \"%s\", %d\n", 	
			kli[x].word,	
			kli[x].def,
			kli[x].code);
	}
	fclose (WT);
    }
}
/*
                    _                   
 _ __ ___  __ _  __| | __   _____   ___ 
| '__/ _ \/ _` |/ _` | \ \ / / _ \ / __|
| | |  __/ (_| | (_| |  \ V / (_) | (__ 
|_|  \___|\__,_|\__,_|___\_/ \___/ \___|
                    |_____|             

*/
read_voc(char *filename){
	FILE *RD;
	int x,num;
	char *k,*e,*i;
	char *kcop, *ecop;
	char FILENM[1000];
	char input[2000];
	strcpy (FILENM,FILEHOME);
	strcat (FILENM,filename);

	if (RD = fopen(FILENM,"r")){

		while (	fgets (input,2000,RD) ){
		  
			k = strchr(input,'\"');

			k++; /*now we have the klingon word*/

			e = strchr(k,'\"');

			*e = (char)0; /*null out end of kli word*/

			e++;

			e = strchr(e,'\"');

			e++; /*now we have start of english word*/

			i = strchr(e,'\"');

			*i = (char)0; /*null out end of eng word*/
			i++; /*find number*/
			sscanf (i,", %d",&num);

			kcop = (char*)malloc(strlen(k)+1);
			ecop = (char*)malloc(strlen(e)+1);
			strcpy(ecop,e);
			strcpy(kcop,k);
			kli[LEXSIZE].word = kcop;
			kli[LEXSIZE].def = ecop;
			kli[LEXSIZE].code = num;
			LEXSIZE++;
			/*			  printf ("%s/%s/%d",kcop,ecop,num);*/
		}

	}
	fclose (RD);
}

void init_vocab(){
int x;

 for (x=0;x<S_LEXSIZE;x++){
   kli[x]=s_kli[x];
 }
 LEXSIZE = S_LEXSIZE;
 read_voc(LEXFILE);

 printf ("Vocabulary initialized at %d entries\n",LEXSIZE);

}

void main(argc,argv)
int argc;
char *argv[];
{
int x;

init_vocab();

if (argc >1 ) {
if (strcmp(argv[1],"-k")==0){
  for (x=2;x<argc;x++) analyze(argv[x]);
}

if (strcmp(argv[1],"-t")==0){
  for (x=2;x<argc;x++) {
	printf ("\n>>> %s >>>\n", argv[x]); 
		dictionary( argv[x]);
	}
}
if (strcmp(argv[1],"-e")==0){
  for (x=2;x<argc;x++) {
if (strlen(argv[x])>=3) {
  dictionary(argv[x]);
}else{
  printf("\n\tghobe'! Word Lookup on 3 letter or greater words!\n");
  break;
}
}

}

	printf("\n\t\t\t\ttlhIngan Hol pojwI'");
   	printf("\n\t\t\t     vj3.3 copyright (1995) by");
   	printf("\n\t\t\t\t  d\'Armond Speers");
   	printf("\n\t\t\t\tAll Rights Reserved");
   	printf("\n\t\t\t     Unix Mods copyright (1999) by Joel Anderson");

exit (0);
}

/*	system("clear");*/
	printf("\n\n\n\n\n\n\n\n\n\n\t\t\t\ttlhIngan Hol pojwI'");
   	printf("\n\t\t\t     vj3.3 copyright (1995) by");
   	printf("\n\t\t\t\t  d\'Armond Speers");
   	printf("\n\t\t\t\tAll Rights Reserved");
   	printf("\n\t\t\t     Unix Mods copyright (1999) by Joel Anderson");

   	pause(1);

   	while(1) 
   	{
    	fflush(stdin);
/*		system("clear");*/
      	printf("\n\t\t\t pojwI' HIDjolev (j3.3)\n");
      	printf(" 1. Translate tlhIngan to English.\n");
      	printf(" 2. Analyze a text file you specify.\n");
      	printf(" 3. Search for tlhIngan using English.\n");
      	printf(" 4. Affix charts.\n");
      	printf(" 5. View text file.\n");
      	printf(" 6. Add a word to the dictionary.\n");
      	printf(" 7. save the dictionary to kli.lex.\n\n\n");
      	printf(" Press 1-7 <enter> (or <Enter> to quit): \n");
      	i_menu_item=getch();
      	     if(i_menu_item == 49) analyze("*NONE*");
      	else if(i_menu_item == 50) translate_file();
      	else if(i_menu_item == 51) dictionary("*NONE*");
      	else if(i_menu_item == 52) special();
      	else if(i_menu_item == 53) view();
      	else if(i_menu_item == 54) addword();
      	else if(i_menu_item == 55) save_voc("kli.lex");
      	else if(i_menu_item == 13) the_end();
      	else 
      	{
	 		printf(" Your selection was not understood.\n");
	 		printf(" Please try again.");
	 		pause(1);
	 		fflush(stdin);
      	}
   	}
}

/****************************************************************************/
/* analyze()                                                                */
/* Menu Option 1.  Type in a word and analyze it.                           */
/****************************************************************************/

void analyze(inp)
char *inp;
{
char ch;
char input_string[255];
int key = '\0';
int j;
int notdone=1;
/*signed int ii;*/
 int ii;
menu=1;

	while(notdone) 
	{
    	j=0;
      	clear_vars();
	
	if (strcmp(inp,"*NONE*")==0){

      	printf("\n Type in word in tlhIngan");
      	printf(" (or Enter to return): ");
      	gets(input_string);
      	if(*input_string == '\0') return;  /* Return on <Enter>. */
      }else{
	strcpy(input_string,inp);
	notdone=0;
      }

      	for(ii=0; ii < strlen(input_string)+1; ++ii) 
      	{
	 		ch=input_string[j++];
	 		if(ch == ' ' || ch == '.'|| ch == '\0') 
	 		{
	    		word[ii]='\0';
	    		if(strlen(word) > 1) parse(word);
	    		ii=-1;
	    		if(ch=='\0') break;
	 		}
	 		/* This line removes non-tlhIngan characters, and appends */
	 		/* tlhIngan characters to 'word'.                         */
	 		ii=screen(ii, ch);
      	}
   	}
}

/****************************************************************************/
/* translate_file()                                                         */
/* Menu Option 2.  Open a file specified by the user, and put all the words */
/*    found through the function 'check_word()'.  Characters such as !, ?,  */
/*    (,), etc., are not read in.  A space or a new-line sets off the       */
/*    search routine.                                                       */
/****************************************************************************/                       /* Menu Option 2.                                 */

void translate_file()
{                    
char file_name[80];  
char line[256];      
FILE *fp;            
FILE *fp2;
char ch;
int ii;
menu = 2;

	printf("\n Type in file name to analyze: ");
   	gets(file_name);
   	if(*file_name == '\0') return;
   	fp = fopen(file_name, "rt");
   	if(fp == NULL ) 
   	{
    	printf("\n Cannot open %s", file_name);
      	any_key();
      	return;
   	}
   	for(ii=0; (ch = fgetc(fp)) != EOF; ++ii) 
   	{
    	if(ch == ' ' || ch == '\n' || ch == '.') 
    	{
	 		word[ii]='\0';
	 		if(strlen(word) > 1) parse(word);
	 		ii=-1;
	 		continue;
      	}
      	ii=screen(ii, ch);   /* This line is explained above.  */
   	}
/*   	fcloseall();*/
fclose(fp);
fclose(fp2);

   	printf("\n Type in file name to append results to,");
   	printf("\n (or type 'none') [%s]: ", file_name);
   	gets(a_file);
   	if(*a_file == '\0') 
   	{
      	strcpy(a_file, file_name);
   	}
   	if(strcmp(a_file, "none")) 
   	{
      	printf(" Appending results to %s...", a_file);
      	fp  = fopen("temp.tkd", "r");
      	fp2 = fopen(a_file, "a");
      	while(fgets(line, 256, fp) != NULL) 
      	{
	 		fputs(line, fp2);
      	}
/*      	fcloseall();*/
fclose(fp);
fclose(fp2);

   	}
   	remove("temp.tkd");
   	printf("\n Done!");
   	any_key();
   	return;
}

/****************************************************************************/
/* dictionary()                                                             */
/* Menu Option 3.  This routine searches through the lexicon definitions    */
/*    for a test string, entered by the user.  All matches are returned,    */
/*    and identified as the appropriate part of speech.                     */
/****************************************************************************/

void dictionary(inp)
char *inp;
{
static char english[MAXENG];
int index4;
int notdone=1;

	while(notdone) 
	{
	  if (strcmp(inp,"*NONE*")==0){
	    printf("\n\n Enter word in English");
	    printf(" (or Enter to return): ");
	    gets(english);
	    if(*english == '\0') return;
	  }else{
	    strcpy(english,inp);
	    notdone=0;
	  }

      /* Return all matches. */

		for(index4 = 0; index4 < LEXSIZE; ++index4) 
		{
		 	if(strstr(kli[index4].def, english)!=NULL) 
	 		{
	    		if(kli[index4].code == 1) 
	    		{
	       			printf("\n N: %s: %s", kli[index4].word, kli[index4].def);
	    		}
	    		if(kli[index4].code == 2) 
	    		{
	       			printf("\n V: %s: %s", kli[index4].word, kli[index4].def);
	    		}
	    		if(kli[index4].code == 3) 
	    		{
	       			printf("\n P: %s: %s", kli[index4].word, kli[index4].def);
	    		}
	    		if(kli[index4].code == 4) 
	    		{
	       			printf("\n A: %s: %s", kli[index4].word, kli[index4].def);
	    		}
	    		if(kli[index4].code == 5) 
	    		{
	       			printf("\n #: %s: %s", kli[index4].word, kli[index4].def);
	    		}
	    		if(kli[index4].code == 6) 
	    		{
	       			printf("\n &: %s: %s", kli[index4].word, kli[index4].def);
	    		}
	    		if(kli[index4].code == 7) 
	    		{
	       			printf("\n !: %s: %s", kli[index4].word, kli[index4].def);
	    		}
	    		if(kli[index4].code == 8) 
	    		{
	       			printf("\n ?: %s: %s", kli[index4].word, kli[index4].def);
	    		}
	 		}
   		}
	}
}

/****************************************************************************/
/* special()                                                                */
/* Menu Option 4.  This section displays charts of all possible noun        */
/* suffixes, and verb prefixes and suffixes.                                */
/****************************************************************************/

void special()
{             
int s_menu_item;

	while(1) 
	{
/*		system("clear");*/
      	printf("\n\n");
      	printf("  1. Noun Suffixes\n");
      	printf("  2. Verb Prefixes\n");
      	printf("  3. Verb Suffixes\n\n");
      	printf("  Type in number <enter>(or <enter>): ");
      	s_menu_item=getch();

      		 if(s_menu_item == 49) nsscreen();
      	else if(s_menu_item == 50) vpscreen();
      	else if(s_menu_item == 51) vsscreen();
      	else return;
   	}
}

/********************************************************************************/
/* parse()                                                                      */
/* Receives 'word' either from analyze() or translate_file(), and evaluates it. */
/********************************************************************************/

void parse(word)
char *word;
{
int n;
int p = 0;
found_flag=0;
x=0;

	/* Are 1st 2 or 3 chars a v prefix? */
	p=v_prefix_parse(word);
  	for(i=0; i<LEXSIZE; ++i) 
  	{
		n=strlen(kli[i].word);               /* Length of current lexicon word. */
    	if(strncmp(word, kli[i].word, n)==0) /* If there's a match... */
      	{  
		 	if(strcmp(word, kli[i].word) == 0)  /* If exact match... */
	 		{
		    	vpsub[0] = '\0';  /* Can't have prefix if exact match! */
		    	vpobj[0] = '\0';
				if(kli[i].code!=5) /* Numbers get their own routine... */
		    	{
			    	show_it(kli[i].code, i);/* Whatever it is, show it. */
	    			continue;  /* See if anything else matches.  Don't give up! */
	    		}
	 		}
		 	if(kli[i].code==5) /* If it's a number, */
		 	{
	 			if(num_parse(n, i)) /* If we succeed, */
	 			{
			 		show_it(5, i);
			 	}
			 	continue;
		 	}
		 	if(kli[i].code==1 || kli[i].code ==3)  /* If it's a noun... */
	 		{ 
		    	vpsub[0]='\0';    /* No prefix on a noun! */
		    	vpobj[0]='\0';
		    	x=n_suffix_parse(n,x,strlen(word),i); /* x=sum(lengths(sufs)) */
	    		if(strlen(word)-n-x==0)  /* If that's all... */
	    		{ 
		       		show_it(kli[i].code, i);
		       		continue;
	    		}
	    		else compound(i, n, x); /* Maybe it's a compound... */
		 	}
		 	if(kli[i].code==2 || kli[i].code==3) /* If it's a verb... */
	 		{ 
	    		vpsub[0]='\0';    /* No prefix yet... */
		    	vpobj[0]='\0';
		    	x=v_suffix_parse(0,n,x,strlen(word),i); /* x=sum(length(sufs)) */
		    	if(strlen(word)-n-x==0)  /* If that's all... */
	    		{ 
	       			show_it(kli[i].code, i);
	       			continue;
		    	}
		    	else if(kli[i].code !=3 && v_to_n_flag==1) /* If last suffix was ghach or wI' */
	    		{
	       			if(strlen(word)-strlen(kli[i].word)-0-x == 0) 
	       			{
			  			show_it(10, i);  /* If that's all, show it. */
			  			return;
	    	   		}
	       			x=n_suffix_parse(n,x,strlen(word),i); /* Look for noun sufs */
	       			if(strlen(word)-0-n-x==0)             /* after ghach or wI' */
		       		{
			  			show_it(10, i);
			  			return;
	       			}
	       			/* If it's a v + ghach or wI', and   */
	       			/* after n suffixes are removed      */
	       			/* there's more, maybe it's a        */
	       			/* compound.                         */
	       			else compound(i, n, x);
	    		}                        
		 	}                           
		}
    	if(kli[i].code !=3 && p!=0)  /* If it _could_ have a prefix... */
    	{
			if(get_verb(word, p, i) == 1)   /* If removing prefix leaves a v, */
			{
	    		x=v_suffix_parse(p,n,0,strlen(word),i); /* Check v sufs.       */
		    	if(strlen(word)-p-n-x==0) /* If that's all, show it.          */
		    	{ 
	    	   		p=v_prefix_parse(word); /* Make sure pref did't get lost.   */
	       			show_it(kli[i].code, i);
		       		continue;
		    	}
	 		}
		}
	}
	if(found_flag == 0) show_it(11, i); /* If nothing showed up, tell me.  */
}

/****************************************************************************/
/* n_suffix_parse()                                                         */
/* This function removes n suffixes from 'word', starting from the position */
/* indicated by the variables that are fed to it.  Stops if no match is     */
/* found.  Returns the sum of the length of the suffixes.                   */
/****************************************************************************/

int n_suffix_parse(n,x,w,i)
int n, x, w, i;
{
int last_found= -1;
int y;             
int j;             
char nsuff[MAXWORD];
char nsdef2[MAXWORD];

	nsdeff[0] = '\0';
   	nsdef2[0] = '\0';
   	while(1) 
   	{
		/* Assigns to a buffer 'word' starting from position shown by variables. */
		strcpy(nsuff, reduce(word, n+x));
     	for(j=0; j<NSLIST; ++j) 
      	{
	 		y=strlen(nsuffixes[j].nsuffix); /* Length of suffix in list. */
	 		if(strncmp(nsuff, nsuffixes[j].nsuffix, y) == 0)  /* If match...*/
	 		{ 
		    	/* If sufs are ordered wrong, turn of flag.*/
		    	if(last_found > nsuffixes[j].ntype) suffix_flag = 1; 
		    	last_found = nsuffixes[j].ntype; /* Keep track of ordering. */
		    	strcat(nsdef2, nsuffixes[j].nsdef);
	    		strcat(nsdef2, nsdeff);          /* Copies suf defintions to */
	    		nsdeff[0] = '\0';                /* nsdeff for later, in the */
		    	strcat(nsdeff, nsdef2);          /* right order.             */
		    	nsdef2[0] = '\0';
	    		x += y;
	    		break;
		 	}
		}
    	if(j==NSLIST) return(x); /* If no match found, return. */
   	}
}

/**************************************************************************/
/* v_suffix_parse()                                                       */
/* This is essentially the same as for nouns, so look there for comments. */
/*    Any differences will be commented.                                  */
/**************************************************************************/

int v_suffix_parse(p,n,x,w,i)
int p, n, x, w, i;
{
int last_found = -1;
int y;
int v;
char vsuff[MAXWORD];
char vsdef2[MAXWORD];

	vsdeff[0]='\0';
   	vsdef2[0]='\0';
   	v_to_n_flag=0;
   	while(1) 
   	{
		/* Also accounts for prefix length. */
		strcpy(vsuff, reduce(word, n+x+p));
     	for(v=0; v < VSLIST; ++v) 
      	{
	 		y=strlen(vsuffixes[v].vsuffix);
	 		if(strncmp(vsuff, vsuffixes[v].vsuffix, y) == 0) 
	 		{
	    		if(last_found > vsuffixes[v].vtype &&       /* Excludes rovers */
				    vsuffixes[v].vtype != 0) 
				{  											/* from ordering.  */
	       			suffix_flag = 1;
	    		}
			    if(vsuffixes[v].vtype != 0) last_found=vsuffixes[v].vtype;
	    		if(v==12 || v==35) v_to_n_flag=1;
	    		strcat(vsdef2, vsuffixes[v].vsdef);
	    		strcat(vsdef2, vsdeff);
	    		vsdeff[0] = '\0';
	    		strcat(vsdeff, vsdef2);
	    		vsdef2[0] = '\0';
	    		x += y;
	    		break;
	 		}
      	}
      	/* If end, or if ghach or wI', return x.     */
      	if(v==VSLIST || v_to_n_flag==1) return(x);
   	}                                              
}

/****************************************************************************/
/* v_prefix_parse()                                                         */
/* Pretty clear by now.  See if 1st 2 or 3 characters could be a vprefix.   */
/*    This function uses the old method, from the original BASIC program,   */
/*    which took too much time.  Since this is a small function, no serious */
/*    loss of time occurs and I decided to leave it alone.  It works.       */
/****************************************************************************/

int v_prefix_parse(verb)
char *verb;
{
int index;
int e;
int f;
char vpref[5];

	vpsub[0] = '\0';
	vpobj[0] = '\0';
   	for(e=2; e < 4; ++e) 
   	{
    	if(strlen(verb) - e < 2) break;
		for(f = 0; f < e; ++f)
		{
			vpref[f] = verb[f];
		}
		vpref[f] = '\0';
     	for(index=0; index < VPREFIXES; ++index) 
      	{
	 		if(strcmp(vpref, prefixes[index].vprefix)==0) 
	 		{
	   			strcat(vpsub, prefixes[index].vpsub);
	   			strcat(vpobj, prefixes[index].vpobj);
	   			return(e);
	 		}
      	}
	}
	return(0);
}

/******************************************************************************/
/* compound()                                                                 */
/* In essence, this function takes the second 1/2 of the word and runs the    */
/*    same analysis on it as in parse().  There's a lot more to keep track of */
/*    here, so it's a bit messy.  It's much, much neater and successful than  */
/*    before, though.                                                         */
/******************************************************************************/

void
compound(i,n,x)
int i,n,x;
{
char cnoun[MAXWORD];
int p;
int ic;
int z;
int temp=x;

	comp_def[0]='\0';       /* Puts 2nd 1/2 of 'word' in string 'cnoun' */
	strcpy(cnoun, reduce(word, n+x));
 	if(vpsub[0] != '\0') {strcat(comp_def, vpsub);   vpsub[0]='\0';}
 	if(vpobj[0] != '\0') {strcat(comp_def, vpobj);   vpobj[0]='\0';}
   	if(nsdeff[0] != '\0'){strcat(comp_def, nsdeff); nsdeff[0]='\0';}
   	if(vsdeff[0] != '\0'){strcat(comp_def, vsdeff); vsdeff[0]='\0';}
   	strcat(comp_def, kli[i].def);  /* These lines (and above) put info   */
   	strcat(comp_def, " | ");       /* from 1st 1/2 of word into the      */
   	p=v_prefix_parse(word);        /* string 'comp_def.'                 */
   	for(ic=0; ic<LEXSIZE; ++ic) 
   	{
    	n=strlen(kli[ic].word);
      	if(strncmp(cnoun, kli[ic].word, n)==0) 
      	{
	 		comp_def2[0]='\0';
	 		if(kli[ic].code==1)   /* If it's a noun... */
	 		{ 
		    	if(strlen(word)-strlen(kli[i].word)-x-strlen(kli[ic].word)==0) 
	    		{
	       			strcat(comp_def2, kli[ic].def);
		       		show_it(9, ic);
		       		x=temp;  /* Reset x to value we started with. */
	    	   		continue;
	    		}
		    	x=n_suffix_parse((n+strlen(kli[i].word)), x, strlen(word),ic);
		    	if(strlen(word)-strlen(kli[i].word)-n-x==0) 
	    		{
	       			strcat(comp_def2, nsdeff);
	       			strcat(comp_def2, kli[ic].def);
		       		show_it(9, ic);
		       		x=temp;
	    	   		continue;
	    		}
		 	}
		 	if(kli[ic].code==2)    /* If it's a verb... */
	 		{
		    	x=v_suffix_parse(0,(n+strlen(kli[i].word)),x,strlen(word),ic);
			    if(v_to_n_flag==1)   /* Only accept it if it ends with ghach   */
			    {
	    	   		if(strlen(word)-strlen(kli[i].word)-p-n-x == 0)   /* or wI' */
	       			{
		  				strcat(comp_def2, vsdeff);
			  			strcat(comp_def2, nsdeff);
			  			strcat(comp_def2, kli[ic].def);
			  			show_it(9, ic);
		  				x=temp;
		  				continue;
		       		}
		       		x=n_suffix_parse((n+strlen(kli[i].word)),x,strlen(word),ic);
	    	   		if(strlen(word)-strlen(kli[i].word)-p-n-x==0) 
	       			{
		  				strcat(comp_def2, vpsub);
		  				strcat(comp_def2, vsdeff);
			  			strcat(comp_def2, nsdeff);
			  			strcat(comp_def2, kli[ic].def);
			  			strcat(comp_def2, vpobj);
			  			show_it(9, ic);
		  				x=temp;
		  				continue;
		       		}
		    	}
	 		}
 		}
	    if(p!=0) 
    	{
			if(get_verb(cnoun, p, ic) == 1) 
			{
		    	z=v_suffix_parse(p,n,0,strlen(cnoun),ic);
	    		if(strlen(cnoun)-p-n-z==0)
	    		{
	       			p=v_prefix_parse(cnoun);
		       		strcat(comp_def2, vpsub);
		       		strcat(comp_def2, vsdeff);
	    	   		strcat(comp_def2, nsdeff);
	       			strcat(comp_def2, kli[ic].def);
	       			strcat(comp_def2, vpobj);
	       			show_it(9, ic);
		       		x=temp;
		       		continue;
	    		}
		 	}
 		}
	}
}

/*************************************************************************/
/* get_verb()                                                            */
/* If 1st 2 or 3 characters could be a verb prefix, see if the resulting */
/*    word could be a verb.                                              */
/*************************************************************************/

int get_verb(word,p,k)
char *word;
 int p, k;
{

	strcpy(preverb, word);
	strcpy(preverb, reduce(word, p));
 	/* If there's a match AND it's a verb... */
	if(strncmp(preverb, kli[k].word, strlen(kli[k].word))==0 && kli[i].code == 2) 
   	{
    	return(1);
   	}
   	return(0);
}

/*******************************************************************/
/* int num_parse()                                                 */
/* This function is called when the input string is matched to     */
/*    a number in the lexicon database.  It's results are appended */
/*    to the global string "num_string", and returns with 1 if     */
/*    successful, and 0 if not.                                    */
/*******************************************************************/

int num_parse(n,i)
int n,i;
{
/* n = the length of the current lexicon word */
/* i = index to the current lexicon word      */
char temp_num[MAXWORD];
int by2 = 0;

	strcpy(temp_num, word);
	
	if(strlen(temp_num) == n)
	{
		/* If it's just a simple number, handle it and return */
		strcpy(num_string, kli[i].def);
		return 1;
	}

	/* Get the end of the word... */
	strcpy(temp_num, reduce(temp_num, n));
	
	/* Test for a multiple of 10 */
	if(!strncmp(temp_num, "maH", 3))
	{
		/* These are all irregular forms, so we have to do each one... */
			 if(!strcmp(kli[i].word, "wa'"))    strcpy(num_string, "ten");
		else if(!strcmp(kli[i].word, "cha'"))   strcpy(num_string, "twenty");
		else if(!strcmp(kli[i].word, "wej"))    strcpy(num_string, "thirty");
		else if(!strcmp(kli[i].word, "loS"))    strcpy(num_string, "forty");
		else if(!strcmp(kli[i].word, "vagh"))   strcpy(num_string, "fifty");
		else if(!strcmp(kli[i].word, "jav"))    strcpy(num_string, "sixty");
		else if(!strcmp(kli[i].word, "Soch"))   strcpy(num_string, "seventy");
		else if(!strcmp(kli[i].word, "chorgh")) strcpy(num_string, "eighty");
		else if(!strcmp(kli[i].word, "Hut"))    strcpy(num_string, "ninety");
		
		/* If we're done, return success */
		if(strlen(temp_num) - 3 == 0) return 1;
		
		/* We're not done, so let's redefine temp_num */
		strcpy(temp_num, reduce(temp_num, 3)); /* 3 is the length of -maH */
	}
	/* Get the def of the number that sent us in here */
	/* (This also clears the contents of num_string)  */
	else strcpy(num_string, kli[i].def);

	/* Check for other number forming elements: vatlh, SaD, SanID, bIp, 'uy' */
		 if(!strncmp(temp_num, "vatlh", 5)) {strcat(num_string, " hundred");         by2=5;}
	else if(!strncmp(temp_num, "SaD",   3)) {strcat(num_string, " thousand");        by2=3;}
	else if(!strncmp(temp_num, "SanID", 5)) {strcat(num_string, " thousand");        by2=5;}
	else if(!strncmp(temp_num, "bIp",   3)) {strcat(num_string, " hundred thousand");by2=3;}
	else if(!strncmp(temp_num, "'uy'",  4)) {strcat(num_string, " million");         by2=4;}
	
    /* If we're done, return, */
	if((strlen(temp_num) - by2) == 0) return 1;
    
    /* We're not done, so let's redefine temp_num */
	if(by2!=0) strcpy(temp_num, reduce(temp_num, by2));
	
	/* Check for some number forming elements relating to time... */
	/* In each case, we check for "one", to distinguish sing/pl   */
	if(!strcmp(temp_num, "leS"))
	{
		  if (!strcmp(word, "wa'leS")) {strcpy(num_string, "tomorrow"); return 1; }
		else {strcat(num_string, " days from now"); return 1;}
	}
	else if(!strcmp(temp_num, "Hu'"))
	{
		  if (!strcmp(word, "wa'Hu'")) {strcpy(num_string, "yesterday"); return 1; }
		else {strcat(num_string, " days ago"); return 1;}
	}
	else if(!strcmp(temp_num, "nem"))
	{
		  if (!strcmp(word, "wa'nem")) {strcpy(num_string, "next year"); return 1;}
		else {strcat(num_string, " years from now"); return 1;}
	}
	else if(!strcmp(temp_num, "ben"))
	{
		  if (!strcmp(word, "wa'ben")) {strcpy(num_string, "last year"); return 1;}
		else {strcat(num_string, " years ago"); return 1;}
	}

	/* Now, check for the ending -DIch */
	if(!strcmp(temp_num, "DIch"))
	{
		/* These first few are irregular forms; just test for 'em... */
		     if(!strcmp(word, "wa'DIch"))   {strcpy(num_string, "first");  return 1;}
		else if(!strcmp(word, "cha'DIch"))  {strcpy(num_string, "second"); return 1;}
		else if(!strcmp(word, "wejDIch"))   {strcpy(num_string, "third");  return 1;}
		else if(!strcmp(word, "vaghDIch"))  {strcpy(num_string, "fifth");  return 1;}
		else if(!strcmp(word, "chorghDIch")){strcpy(num_string, "eighth"); return 1;}
		else if(!strcmp(word, "HutDIch"))   {strcpy(num_string, "ninth");  return 1;}
		else
		{
			/* For everything else, just append "th"    */
			/* If the word ends in -y, change it to -ie */
			if(num_string[strlen(num_string)-1] == 'y')
			{
				num_string[strlen(num_string)-1] = 'i';
				strcat(num_string, "e");
			}
			strcat(num_string, "th");
		}
		/* We're done, so let's go home. */
		return 1;
	}
	
	/* Now, check for the ending -logh */
	if(!strcmp(temp_num, "logh"))
	{
		/* Again, a couple of irregular forms... */
		     if(!strcmp(word, "wa'logh")) strcpy(num_string, "once");
		else if(!strcmp(word, "cha'logh"))strcpy(num_string, "twice");
		else
		{
			/* Everything else just gets " times":          */
			/*   "seven times", "forty million times", etc. */
			strcat(num_string, " times");
		}
		return 1;
	}

	/* If we made it this far, assume it's not a number... */
	return 0;
}

/************************************************************/
/* reduce()                                                 */
/* Generic function to take a chunk off the beginning of a  */
/* string.  The string 'str' is reduced by 'by' characters. */
/************************************************************/

char* reduce(str,by)
char* str;
 int by;
{
int counter;

	for(counter = 0; counter < strlen(str) - by; ++counter)
	{
		temp[counter] = str[counter + by];
	}
	temp[counter] = '\0';
	
	return temp;
}

/**************************************************/
/* the_end()                                      */
/* Display a little message as the program quits. */
/**************************************************/

void the_end()
{
	printf("\n Qapla'!\n");
	exit(0);
}

/*****************************************************************/
/* any_key()                                                     */
/* Displays a message and waits for the user to press any key... */
/*****************************************************************/

void any_key()
{
	printf("\n Press any key to continue...");
	getch();
}


/**************************************************/
/* addword()                                      */
/* Add a word to the dictionary kli.lex           */
/* Not very sophistocated, but it's better than   */
/* nothing!                                       */
/**************************************************/
addword()           
{                    
  char inputw[1000];
  char inputd[1000];
  printf ("\nAdd a word\n");
  printf (" 1 Noun \n"); 
  printf (" 2 Verb \n");
  printf (" 3 Pronoun \n");
  printf (" 4 Adverb\n");
  printf (" 5 Number \n");
  printf (" 6 Conjunction \n");
  printf (" 7 Exclamation \n");
  printf (" 8 Question word \n");
  printf (" 0 never mind\n");
  printf ("\n");
  printf ("\n");
  scanf ("%d", &kli[LEXSIZE].code);
  if ((kli[LEXSIZE].code >=1)&&(kli[LEXSIZE].code <=8)){
    printf ("Klingon Word followed by definition: ");
    scanf ("%s",inputw);
    kli[LEXSIZE].word = (char*)malloc(strlen(inputw)+1);
    strcpy(kli[LEXSIZE].word,inputw);
    gets (inputd);
    kli[LEXSIZE].def = (char*)malloc(strlen(inputd)+1);
    strcpy(kli[LEXSIZE].def,inputd);
    printf ("added!\n");
    LEXSIZE++;
    save_voc("temp.lex");
  }else{
    printf ("never mind!\n");
  }
}


/**************************************************/
/* view()                                         */
/* Dinky little function to display a text file.  */
/* Not very sophistocated, but it's better than   */
/* nothing!                                       */
/**************************************************/

void view()           
{                    
char view_file[50];
char line[80];
FILE *fp;

	int line_num = 0;
   	printf("\n File to view (or <Enter> to return): ");
   	gets(view_file);
   	if(*view_file == '\0') return;
   	fp = fopen(view_file, "r");
   	while(fgets(line, 80, fp) != NULL) 
   	{
    	if(line_num > 23) 
    	{
	 		line_num=0;
	 		any_key();
      	}
      	fputs(line, stdout);
      	++line_num;
   	}
	fclose(fp);
   	any_key();
   	return;
}

/***************************************************************************/
/* void show_it()                                                          */
/* Keeps all the display info in one place.  The output string 'Output' is */
/*    formatted appropriately for all possible parts of speech.  Then,     */
/*    it's printed at the bottom of the function.  Also, if we're called   */
/*    from the file-analysis menu option, the string 'Output' is appended  */
/*    to the temporary output file.  This is much cleaner than before.     */
/***************************************************************************/

void show_it(code,i)
int code,i;
{
char Output[255];
found_flag = 1;


	Output[0] = '\0'; /* Make sure it's clear */
	if(suffix_flag == 1) printf("\n Incorrect suffix ordering.\n");

	if(code == 1)   /* If it's a noun...*/
	{
		strcat(Output, " N: ");
		strcat(Output, word);
		strcat(Output, ": ");
		strcat(Output, nsdeff);
		strcat(Output, " ");
		strcat(Output, kli[i].def);
	}
	if(code == 2)   /* If it's a verb... */
	{
  		strcat(Output, " V: ");
   	  	strcat(Output, word);
   	  	strcat(Output, ": ");
   	  	strcat(Output, vpsub);
   	  	strcat(Output, " ");
   	  	strcat(Output, vsdeff);
   	  	strcat(Output, " ");
   	  	strcat(Output, kli[i].def);
   	  	strcat(Output, " ");
   	  	strcat(Output, vpobj);
  	}
	if(code == 3) /* If it's a pronoun... */
	{
		/* If it's just the pronoun... */
		if(vsdeff[0] == '\0' && nsdeff[0] == '\0')
		{
	   	  	strcat(Output, " P: ");
   		  	strcat(Output, word);
   	  		strcat(Output, ": ");
   	  		strcat(Output, kli[i].def);
   	  	}
   	  	/* If it's acting as a verb... */
		else if(vsdeff[0]!='\0')
		{
			strcat(Output, " P: ");
   		  	strcat(Output, word);
   	  		strcat(Output, ": ");
	   	  	strcat(Output, vsdeff);
   		  	strcat(Output, " ");
   	  		strcat(Output, kli[i].def);
	   	  	strcat(Output, " (to be)");
		}
		/* Otherwise, it's a pronoun with noun suffixes... */
		else
		{
			strcat(Output, " P: ");
   		  	strcat(Output, word);
   	  		strcat(Output, ": ");
			strcat(Output, nsdeff);
			strcat(Output, " ");
			strcat(Output, kli[i].def);
		}
   	}
	if(code == 4) /* If it's an adverb, */
	{
   	  	strcat(Output, " A: ");
   	  	strcat(Output, word);
   	  	strcat(Output, ": ");
   	  	strcat(Output, kli[i].def);
	}
	if(code == 5) /* If it's a number, */
	{
   	  strcat(Output, " #: ");
   	  strcat(Output, word);
   	  strcat(Output, ": ");
   	  strcat(Output, num_string);
  	}
	if(code == 6) /* If it's a conjunction, */
	{
   	  strcat(Output, " &: ");
   	  strcat(Output, word);
   	  strcat(Output, ": ");
   	  strcat(Output, kli[i].def);
	}
	if(code == 7) /* If it's an exclamation, */
	{
   	  strcat(Output, " !: ");
   	  strcat(Output, word);
   	  strcat(Output, ": ");
   	  strcat(Output, kli[i].def);
	}
	if(code == 8) /* If it's a question word,  */
	{
   	  strcat(Output, " ?: ");
   	  strcat(Output, word);
   	  strcat(Output, ": ");
   	  strcat(Output, kli[i].def);
	}
	if(code == 9)   /* If it's a compound noun... */
	{
   		strcat(Output, " C: ");
   	  	strcat(Output, word);
   	  	strcat(Output, ": ");
   	  	strcat(Output, comp_def);
   	  	strcat(Output, " ");
   	  	strcat(Output, comp_def2);
   	}
   	if(code == 10)   /* If it's a nominalized verb... */
   	{
   	  	strcat(Output, " N: ");
   	  	strcat(Output, word);
   	  	strcat(Output, ": ");
   	  	strcat(Output, nsdeff);
   	  	strcat(Output, " ");
   	  	strcat(Output, vpsub);
   	  	strcat(Output, " ");
   	  	strcat(Output, vsdeff);
   	  	strcat(Output, " ");
   	  	strcat(Output, kli[i].def);
   	  	strcat(Output, " ");
   	  	strcat(Output, vpobj);
   	}
   	if(code == 11)   /* If it's nothing... */
   	{
	  	strcat(Output, " X: ");
   	  	strcat(Output, word);
   	  	strcat(Output, ": *** NOT FOUND ***\n");
	}

	/* We're done initializing the output, let's show it... */
	printf("\n%s\n", Output);

   if(menu == 2) {  /* If we're analyzing a file, put info into a temp  */
      FILE *fp2;    /* file.  Later we'll decide what to do with it.    */
      fp2 = fopen("temp.tkd", "a");
      if(suffix_flag == 1) fputs("\n Incorrect suffix ordering.\n", fp2);
      fputs("\n", fp2);
	  fputs(Output, fp2);
      fclose(fp2);
   }
   clear_vars();
}

/*****************************************************************************/
/* clear_vars()                                                              */
/* Function to reset global strings to null between analyses.                */
/*****************************************************************************/

void clear_vars()
{
   nsdeff[0] = '\0';
   vsdeff[0] = '\0';
   vpsub[0] = '\0';
   vpobj[0] = '\0';
   suffix_flag =0;
   i_menu_item = 0;
   x = 0;
   fflush(stdin);
   v_to_n_flag=1;
}

/*****************************************************************************/
/* screen()                                                                  */
/* These are non-tlhIngan characters.                                        */
/* Ignore them!                                                              */
/*****************************************************************************/

int screen(ii,ch)
int ii; 
char ch;
{
	if(ch != '!'  && ch != '?' && ch != '('  && ch != ')'
   	&& ch != ','  && ch != ';' && ch != ':'  && ch != '-'
   	&& ch != '~'  && ch != '<' && ch != '>'  && ch != '\"'
   	&& ch != '\n' && ch != '|' && ch != '\f' && ch != '\t'
   	&& ch != '@'  && ch != '#' && ch != '$'  && ch != '%'
   	&& ch != '^'  && ch != '&' && ch != '*'  && ch != '_'
   	&& ch != '+'  && ch != '{' && ch != '}'  && ch != '['
   	&& ch != ']'  && ch != '`' && ch != '\\' && ch != '/') 
   	{
		word[ii]=ch;
   	}
   	else --ii;
   	return(ii);
}

/*******************************************************/
/* These final screens display the affix charts.  The  */
/* These final screens display the affix charts.  The  */
/* normal indentation scheme adopted here is suspended */
/* due to the width of the charts.                     */
/*******************************************************/

void             
vpscreen()       
{                
/*system("clear");*/
printf("\n\n");
printf("\t+--------------------------------------------------------------+\n");
printf("\t|                          VERB PREFIXES                       |\n");
printf("\t+------------+------+------+------+-------+------+------+------+\n");
printf("\t| OBJECT     | none | me   | you  | him/  | us   | you  | them |\n");
printf("\t|            |      |      |      | her/it|      | (pl) |      |\n");
printf("\t|            |      |      |      |       |      |      |      |\n");
printf("\t| SUBJECT    |      |      |      |       |      |      |      |\n");
printf("\t+------------+------+------+------+-------+------+------+------+\n");
printf("\t| I          | jI-  | ---- | qa-  | vI-   | ---- | Sa-  | vI-  |\n");
printf("\t+------------+------+------+------+-------+------+------+------+\n");
printf("\t| you        | bI-  | cho- | ---- | Da-   | ju-  | ---- | Da-  |\n");
printf("\t+------------+------+------+------+-------+------+------+------+\n");
printf("\t| he/she/it  | O    | mu-  | Du-  | O     | nu-  | lI-  | O    |\n");
printf("\t+------------+------+------+------+-------+------+------+------+\n");
printf("\t| we         | ma-  | ---- | pI-  | wI-   | ---- | re-  | DI-  |\n");
printf("\t+------------+------+------+------+-------+------+------+------+\n");
printf("\t| you (pl)   | Su-  | tu-  | ---- | bo-   | che- | ---- | bo-  |\n");
printf("\t+------------+------+------+------+-------+------+------+------+\n");
printf("\t| they       | O    | mu-  | nI-  | lu-   | nu-  | lI-  | O    |\n");
printf("\t+------------+------+------+------+-------+------+------+------+");
getch();
}

void
vsscreen()
{
/*system("clear");*/
printf("+--------------------------------------------------------------------------+\n");
printf("|                                   VERBS                                  |\n");
printf("+-------------------------------------++-----------------------------------+\n");
printf("|Suffix  Type  Meaning                ||Suffix  Type  Meaning              |\n");
printf("+--------+---+------------------------++--------+---+----------------------+\n");
printf("| -ba'   | 6 | obviously              || -moH   | 4 | cause                |\n");
printf("| -beH   | 2 | ready, set up (devices)|| -mo'   | 9 | because              |\n");
printf("| -bej   | 6 | certainly, undoubtedly || -neS   | 8 | honorific            |\n");
printf("| -be'   | R | not                    || -nIS   | 2 | need                 |\n");
printf("| -bogh  | 9 | which (relative-clause)|| -pa'   | 9 | before               |\n");
printf("| -choH  | 3 | change                 || -pu'   | 7 | perfective           |\n");
printf("| -chugh | 9 | if                     || -qang  | 2 | willing              |\n");
printf("| -chuq  | 1 | one another            || -qa'   | 3 | do again,resume      |\n");
printf("| -chu'  | 6 | clearly, perfectly     || -qu'   | R | emphatic             |\n");
printf("| -DI'   | 9 | as soon as, when       || -Qo'   | R | don't!,won't         |\n");
printf("| -ghach | 9 | nominalizer            || -rup   | 2 | ready,prepared       |\n");
printf("| -Ha'   | R | undo                   || -taH   | 7 | continuous           |\n");
printf("| -jaj   | 9 | may                    || -ta'   | 7 | accomplished, done   |\n");
printf("| -laH   | 5 | can, able              || -vIp   | 2 | afraid               |\n");
printf("| -law'  | 6 | seems, apparently      || -vIS   | 9 | while                |\n");
printf("| -lI'   | 7 | in progress            || -wI'   | 9 | one/thing who is/does|\n");
printf("| -lu'   | 5 | indefinite subject     || -'a'   | 9 | interrogative        |\n");
printf("| -meH   | 9 | for (purpose-clause)   || -'egh  | 1 | oneself              |\n");
printf("+--------+---+------------------------++--------+---+----------------------+");
getch();
}

void
nsscreen()
{
/*system("clear");*/
printf("\n");
printf("     +----------------------------------------------------------------------+\n");
printf("     |                           NOUN SUFFIXES                              |\n");
printf("     +---------------------------------++-----------------------------------+\n");
printf("     | Suffix Type  Meaning            || Suffix Type  Meaning              |\n");
printf("     +--------+---+--------------------++--------+---+----------------------+\n");
printf("     | -chaj  | 4 | their              || -oy    | 1 | endearment           |\n");
printf("     | -Daj   | 4 | his/her            || -pu'   | 2 | plural (language)    |\n");
printf("     | -Daq   | 5 | locative           || -qoq   | 3 | so-called            |\n");
printf("     | -Du'   | 2 | plural (body part) || -raj   | 4 | your (pl)            |\n");
printf("     | -Hey   | 3 | apparent           || -ra'   | 4 | your (pl) (language) |\n");
printf("     | -Hom   | 1 | diminutive         || -vaD   | 5 | for                  |\n");
printf("     | -lIj   | 4 | your               || -vam   | 4 | this                 |\n");
printf("     | -lI'   | 4 | your (language)    || -vetlh | 4 | that                 |\n");
printf("     | -maj   | 4 | our                || -vo'   | 5 | from                 |\n");
printf("     | -ma'   | 4 | our (language)     || -wIj   | 4 | my                   |\n");
printf("     | -mey   | 2 | plural (general)   || -wI'   | 4 | my (language)        |\n");
printf("     | -mo'   | 5 | due to             || -'a'   | 1 | augmentative         |\n");
printf("     | -na'   | 3 | definite           || -'e'   | 5 | topic                |\n");
printf("     +--------+---+--------------------++--------+---+----------------------+");
getch();
}

/* Pause Routine */

void pause(sec)
int sec;
{
long time_passed;
long secs=sec;

	for(time_passed=1, secs*=200000; time_passed < secs; ++time_passed);
}
